summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorTorsten Veller <tove@gentoo.org>2010-04-17 19:56:27 +0000
committerTorsten Veller <tove@gentoo.org>2010-04-17 19:56:27 +0000
commit64b81bf0f05832392eff5a7e6e1b63df360eea0b (patch)
treed566cbfb572937352572add9bd5ee66145528c6c /eclass/perl-helper.eclass
parentnon-maintainer commit: version bump for security bug #284561 (diff)
downloadhistorical-64b81bf0f05832392eff5a7e6e1b63df360eea0b.tar.gz
historical-64b81bf0f05832392eff5a7e6e1b63df360eea0b.tar.bz2
historical-64b81bf0f05832392eff5a7e6e1b63df360eea0b.zip
Add perl-helper.eclass (#302183) and update perl-module.eclass per <http://archives.gentoo.org/gentoo-dev/msg_82ff2383bd5836dda541d0b2b4685ec8.xml>. Add support for EAPI=3 (#310513). Removes "AppleDouble encoded Macintosh files" (#268497)
Diffstat (limited to 'eclass/perl-helper.eclass')
-rw-r--r--eclass/perl-helper.eclass130
1 files changed, 130 insertions, 0 deletions
diff --git a/eclass/perl-helper.eclass b/eclass/perl-helper.eclass
new file mode 100644
index 000000000000..11cd29ae5ecd
--- /dev/null
+++ b/eclass/perl-helper.eclass
@@ -0,0 +1,130 @@
+# Copyright 1999-2010 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/eclass/perl-helper.eclass,v 1.1 2010/04/17 19:56:27 tove Exp $
+
+[[ ${CATEGORY} == "perl-core" ]] && inherit alternatives
+
+perlinfo() {
+ debug-print-function $FUNCNAME "$@"
+ perl_set_version
+}
+
+perl_set_version() {
+ debug-print-function $FUNCNAME "$@"
+ debug-print "$FUNCNAME: perlinfo_done=${perlinfo_done}"
+ ${perlinfo_done} && return 0
+ perlinfo_done=true
+
+ local f version install{{site,vendor}{arch,lib},archlib}
+ eval "$(perl -V:{version,install{{site,vendor}{arch,lib},archlib}} )"
+ PERL_VERSION=${version}
+ SITE_ARCH=${installsitearch}
+ SITE_LIB=${installsitelib}
+ ARCH_LIB=${installarchlib}
+ VENDOR_LIB=${installvendorlib}
+ VENDOR_ARCH=${installvendorarch}
+}
+
+fixlocalpod() {
+ debug-print-function $FUNCNAME "$@"
+ perl_delete_localpod
+}
+
+perl_delete_localpod() {
+ debug-print-function $FUNCNAME "$@"
+
+ find "${D}" -type f -name perllocal.pod -delete
+ find "${D}" -depth -mindepth 1 -type d -empty -delete
+}
+
+perl_fix_osx_extra() {
+ debug-print-function $FUNCNAME "$@"
+
+ local f
+ find "${S}" -type f -name "._*" -print0 | while read -rd '' f ; do
+ einfo "Removing AppleDouble encoded Macintosh file: ${f#${S}/}"
+ rm -f "${f}"
+ f=${f#${S}/}
+ # f=${f//\//\/}
+ # f=${f//\./\.}
+ # sed -i "/${f}/d" "${S}"/MANIFEST || die
+ grep -q "${f}" "${S}"/MANIFEST && \
+ elog "AppleDouble encoded Macintosh file in MANIFEST: ${f}"
+ done
+}
+
+perl_delete_module_manpages() {
+ debug-print-function $FUNCNAME "$@"
+
+ perl_set_eprefix
+
+ if [[ -d "${ED}"/usr/share/man ]] ; then
+# einfo "Cleaning out stray man files"
+ find "${ED}"/usr/share/man -type f -name "*.3pm" -delete
+ find "${ED}"/usr/share/man -depth -type d -empty -delete
+ fi
+}
+
+
+perl_delete_packlist() {
+ debug-print-function $FUNCNAME "$@"
+ perl_set_version
+ if [[ -d ${D}/${VENDOR_LIB} ]] ; then
+ find "${D}/${VENDOR_LIB}" -type f -a \( -name .packlist \
+ -o \( -name '*.bs' -a -empty \) \) -delete
+ find "${D}/${VENDOR_LIB}" -depth -mindepth 1 -type d -empty -delete
+ fi
+}
+
+perl_remove_temppath() {
+ debug-print-function $FUNCNAME "$@"
+
+ find "${D}" -type f -not -name '*.so' -print0 | while read -rd '' f ; do
+ if file "${f}" | grep -q -i " text" ; then
+ grep -q "${D}" "${f}" && ewarn "QA: File contains a temporary path ${f}"
+ sed -i -e "s:${D}:/:g" "${f}"
+ fi
+ done
+}
+
+perl_link_duallife_scripts() {
+ debug-print-function $FUNCNAME "$@"
+ if [[ ${CATEGORY} != perl-core ]] || ! has_version ">=dev-lang/perl-5.8.8-r8" ; then
+ return 0
+ fi
+
+ perl_set_eprefix
+
+ local i ff
+ if has "${EBUILD_PHASE:-none}" "postinst" "postrm" ; then
+ for i in "${DUALLIFESCRIPTS[@]}" ; do
+ alternatives_auto_makesym "/usr/bin/${i}" "/usr/bin/${i}-[0-9]*"
+ ff=`echo "${EROOT}"/usr/share/man/man1/${i}-${PV}-${P}.1*`
+ ff=${ff##*.1}
+ alternatives_auto_makesym "/usr/share/man/man1/${i}.1${ff}" "/usr/share/man/man1/${i}-[0-9]*"
+ done
+ else
+ pushd "${ED}" > /dev/null
+ for i in $(find usr/bin -maxdepth 1 -type f 2>/dev/null) ; do
+ mv ${i}{,-${PV}-${P}} || die
+ DUALLIFESCRIPTS[${#DUALLIFESCRIPTS[*]}]=${i##*/}
+ if [[ -f usr/share/man/man1/${i##*/}.1 ]] ; then
+ mv usr/share/man/man1/${i##*/}{.1,-${PV}-${P}.1} || die
+ fi
+ done
+ popd > /dev/null
+ fi
+}
+
+perl_set_eprefix() {
+ debug-print-function $FUNCNAME "$@"
+ case ${EAPI:-0} in
+ 0|1|2)
+ if ! use prefix; then
+ EPREFIX=
+ ED=${D}
+ EROOT=${ROOT}
+ fi
+ ;;
+ esac
+}